/*
-- Uncomment this SQL to create a table for Users
create table `acl_user` (
    id bigint not null auto_increment,
    username varchar(50) not null,
    password varchar(96) not null,
    constraint `pk_acl_user` primary key (id)
);*/

create table `acl_role` (
    id bigint not null auto_increment,
    name varchar(50) not null,
    constraint `pk_acl_role` primary key (id)
);

/*
-- Uncomment this SQL to create a join table between Users and Roles
create table `acl_user_role` (
    user_id bigint not null,
    role_id bigint not null,
    constraint `pk_acl_user_role` primary key (user_id, role_id),
    constraint `fk_acl_user_acl_user_role_user_id`
        foreign key (user_id) references `acl_user` (id),
    constraint `fk_acl_role_acl_user_role_role_id`
        foreign key (role_id) references `acl_role` (id)
);*/

create table `acl_app_uri` (
    uri varchar(192) not null
);

create table `acl_resource` (
    id bigint not null auto_increment,
    role_id bigint not null,
    uri varchar(192) not null,
    constraint `pk_acl_resource` primary key (id),
    constraint `fk_acl_role_acl_resource_role_id`
        foreign key (role_id) references `acl_role` (id)
);

create unique index `idx_acl_role_name` on `acl_role` (name);
create unique index `idx_acl_role_resource_role_uri` on `acl_resource` (role_id, uri);
create unique index `idx_app_uri` on `acl_app_uri` (uri);
