create schema "acl";

/*
-- Uncomment this SQL to create a table for Users
create table "acl"."user" (
    id bigserial not null,
    username varchar(50) not null,
    password varchar(96) not null
    constraint "pk_user" primary key (id)
);
*/

create table "acl"."app_uri" (
    uri varchar(192) not null
);

create table "acl"."role" (
    id bigserial not null,
    name varchar(50) not null,
    constraint "pk_role" primary key (id)
);

/*
-- Uncomment this SQL to create a join table between Users and Roles
create table "acl"."user_role" (
    user_id bigint not null,
    role_id bigint not null,
    constraint "pk_user_role" primary key (user_id, role_id),
    constraint "fk_user_user_role_user_id"
        foreign key (user_id) references "acl"."user" (id)
    constraint "fk_role_user_role_role_id"
        foreign key (role_id) references "acl"."role" (id)
);
*/

create table "acl"."resource" (
    id bigserial not null,
    role_id bigint not null,
    uri varchar(192) not null,
    constraint "pk_resource" primary key (id),
    constraint "fk_role_resource_role_id"
        foreign key (role_id) references "acl"."role" (id)
);

create unique index "idx_role_name" on "acl"."role" (name);
create unique index "idx_resource_role_uri" on "acl"."resource" (role_id, uri);
create unique index "idx_app_uri" on "acl"."app_uri" (uri);
